﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	
	public class Airplane extends MovieClip {
		private var dx:Number; // speed and direction
		private var lastTime:int; // animation time
		
		public function Airplane(side:String, speed:Number, altitude:Number) {
			if (side == "left") {
				this.x = -50; // start to the left
				dx = speed; // fly left to right
				this.scaleX = -1; // reverse
			} else if (side == "right") {
				this.x = 1200; // start to the right
				dx = -speed; // fly right to left
				this.scaleX = 1; // not reverse
			}
			this.y = altitude; // vertical position
			
			// choose a random plane
			this.gotoAndStop(Math.floor(Math.random()*5+1));
			
			// set up animation
			addEventListener(Event.ENTER_FRAME,movePlane);
			lastTime = getTimer();
		}
		
		public function movePlane(event:Event) {
			// get time passed
			var timePassed:int = getTimer()-lastTime;
			lastTime += timePassed;
			
			// move plane
			this.x += dx*timePassed/1000;
			
			// check to see if off screen
			if ((dx < 0) && (x < -50)) {
				deletePlane();
			} else if ((dx > 0) && (x > 600)) {
				deletePlane();
			}
			
		}
		
		// plane hit, show explosion
		public function planeHit() {
			removeEventListener(Event.ENTER_FRAME,movePlane);
			MovieClip(parent).removePlane(this);
			gotoAndPlay("explode");
		}
		
		// delete plane from stage and plane list
		public function deletePlane() {
			removeEventListener(Event.ENTER_FRAME,movePlane);
			MovieClip(parent).removePlane(this);
			parent.removeChild(this);
		}
		
	}
}
